package projectconfigurator;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jdt.core.IClasspathEntry;
import org.eclipse.jdt.core.IJavaProject;
import org.eclipse.jdt.core.JavaCore;

import org.eclipse.buildship.core.InitializationContext;
import org.eclipse.buildship.core.ProjectConfigurator;
import org.eclipse.buildship.core.ProjectContext;


public class ProjectConfigurator1 implements ProjectConfigurator {

    public ProjectConfigurator1() {
    }

    @Override
    public void init(InitializationContext context, IProgressMonitor monitor) {
    }

    @Override
    public void configure(ProjectContext context, IProgressMonitor monitor) {

        try {
            IJavaProject project = JavaCore.create(context.getProject());
            IClasspathEntry[] cp = project.getRawClasspath();

            // find Gradle and GWT cp container
            int idxGradle = -1;
            int idxGwt = -1;
            for (int i = 0; i < cp.length; ++i) {
                if (cp[i].getPath().toPortableString().contains("com.google.gwt.eclipse.core.GWT_CONTAINER")) {
                    idxGwt = i;
                } else if (cp[i].getPath().toPortableString().contains("org.eclipse.buildship.core.gradleclasspathcontainer")) {
                    idxGradle = i;
                }
            }

            // swap containers
            if (idxGradle >=0 && idxGwt >= 0 && idxGradle > idxGwt) {
                IClasspathEntry e = cp[idxGradle];
                cp[idxGradle] = cp[idxGwt];
                cp[idxGwt] = e;
            }
            project.setRawClasspath(cp, monitor);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }

    }

    @Override
    public void unconfigure(ProjectContext context, IProgressMonitor monitor) {
    }

}
